Subject: Re: Segfault in xdl_merge is back

From: Shawn Pearce <[email-masked]>
Date: Wed, 27 Dec 2006 03:24:40 -0500

Linus Torvalds <[email-masked]> wrote:
> On Tue, 26 Dec 2006, Shawn Pearce wrote:
> > 
> > I'm suspecting this is actually some sort of memory corruption in
> > the heap (due to a bad malloc/free) as the bug seems to rear its
> > head only based on the data we are allocating/have allocated.
> 
> Can you try to reproduce it under Linux and use "valgrind" to run the 
> thing that SIGSEGV's? That tends to be a pretty good way to debug bad 
> allocations..
> 
> So instead of bisecting it on cygwin, try to use the build that broke on 
> Linux too (ie undo the 5caf9232 "fix") and when you can reproduce it under 
> Linux, compiel withour -O2 and with debug information, and gdb will be a 
> lot more useful, but also run it with valgrind..

Good advice.  Unfortunately it may be difficult to get valgrind onto
a Linux system where I can also put that repository which is failing.

Junio suggested that I try running git-merge-file on the three
blobs that I'm segfaulting on.  That's a pretty quick test.

Failing that I may have to find a way to get valgrind onto a Linux
system - but that could take a month or more.  (The UNIX admins
are overworked and don't care much about Linux, and I don't have
my own Linux system there.)

I'd really like to get this segfault fixed before 1.5.0 ships. Its
a rather nasty bug and I suspect the culprit is already in 1.5.0-rc0.

-- 
Shawn.